;	PETR SIMANDL
;	VIDEO KARTA PRO V32X32 - GENERATOR VIDEOSIGNALU
	LIST	P=16C84

;PORTY : 	PA0	..	IMPULS
;	PA1	..	VIDEO
;	PA2	..	SIGN
;	PA3	..	SWA
;	PA4	..	SWB
;	PB0       ..	D0
;	PB1       ..	D1
;	PB2       ..	D2
;	PB3       ..	D3
;	PB4       ..	D4
;	PB5       ..	D5
;	PB6       ..	LEX
;	PB7	..	LEY

;	KRYSTAL 6.144MHz
;	DOBA RADKU     H  = 98T = 64us
;	DOBA SNIMKU    TP = 625H

IMP	EQU	0
VID	EQU	1
SIG	EQU	2

LEX	EQU	6
LEY	EQU	7

NUMVI	EQU	D'5'	;POCET VYROVNAVACICH IMPULSU
NUMUI	EQU	D'5'	;POCET UDRZOVACICH IMPULSU
NUMRSI	EQU	D'17'	;POCET PASIVNICH RADEK PRED PULSNIMKEM
NUMLIN	EQU	D'143'	;POCET AKTIVNICH DVOU-RADEK V PULSNIMKU


XT	EQU	D'1'	;POCET TAKTU NA JEDEN PIXEL
YR	EQU	D'5'	;POCET RADKU NA JEDEN PIXEL
YSTART	EQU	D'71'	;ZACATECNI RADEK POLE PIXELU

XSIZE	EQU	D'32'	;POCET SLOUPCU KAMERY
YSIZE	EQU	D'32'	;POCET RADKU KAMERY


	ORG	0H
START     MOVLW	B'11110000'
          MOVWF	PA
	TRIS	PA
	MOVLW	B'00000000'	;PB cela vystupni
	MOVWF	PB
	TRIS	PB	
	MOVLW	B'11010111'	;F/(4*256)	
          OPTION
          CLRWDT

	CLRW	PB    		;VYNULOVANI ADRESACE PIXELU
	BSF	PB,LEX
	NOP
	BCF	PB,LEX
	BSF	PB,LEY
	NOP
	BCF	PB,LEY
	
	
LOOP	BCF	PA,VID	;98
	BSF	PA,IMP	;1	POSLEDNI PULRADEK
	CALL	DT8	;9	LICHEHO PULSNIMKU
	BCF	PA,IMP	;10
	CALL	DT7	;17
	BSF	PA,VID	;18

	MOVLW	D'5'	;19
	NOP		;20
	NOP		;21
	NOP		;22
	CALL	DELAY	;22 + 8+(4*4)=46

	MOVLW	NUMVI	;47
	MOVWF	RAM0	;48
	BCF	PA,VID	;49

;##################################
;#        SUDY PULSNIMEK          #
;##################################

VI1	BSF	PA,IMP	;1	5 VYROVNAVACICH IMPULSU
	CALL	DT4	;5
	BCF	PA,IMP	;6

	DECF	RAM0	;7
	BTFSC	STATUS,Z	;8
	GOTO	EVI1	;9	;10

	MOVLW	D'8'	;10
	BSF	PB,0	;11
	CALL	DELAY	;11 + 8+(4*7)=47

	GOTO	VI1	;49

EVI1	MOVLW	D'8'	;11
	CALL	DELAY	;11 + 8+(4*7)=47

	MOVLW	NUMUI     ;48
	MOVWF	RAM0      ;49

UI1	BSF	PA,IMP	;1

	MOVLW	D'8'	;2
	NOP		;3
	NOP		;4
	NOP		;5
	CALL	DELAY	;5 + 8+(4*7)=41

	BCF	PA,IMP	;42

	DECF	RAM0	;43
	BTFSC	STATUS,Z	;44
	GOTO	EUI1	;45	;46

	NOP		;46
	NOP		;47
	GOTO	UI1	;49

EUI1	NOP		;47

	MOVLW	NUMVI	;48
	MOVWF	RAM0	;49

VI2	BSF	PA,IMP	;1
	CALL	DT4	;5
	BCF	PA,IMP	;6

	DECF	RAM0	;7
	BTFSC	STATUS,Z	;8
	GOTO	EVI2	;9	;10

	MOVLW	D'8'	;10
	NOP		;11
	CALL	DELAY	;11 + 8+(4*7)=47

	GOTO	VI2	;49

EVI2	MOVLW	D'8'	;11
	CALL	DELAY	;11 + 8+(4*7)=47

	MOVLW	NUMRSI	;48
	MOVWF	RAM0	;49

RSI1	BSF	PA,IMP	;1	;PASIVNI RADEK
	CALL	DT8	;9
	BCF	PA,IMP	;10

	DECF	RAM0	;11
	BTFSC	STATUS,Z	;12
	GOTO	ERSI1	;13	;14

	MOVLW	D'19'	;14                 ;#####
	NOP		;15
	NOP		;16
	CALL	DELAY	;16 + 8+(4*18)=96   ;#####

     	GOTO	RSI1	;98
     	
ERSI1

	CALL	SCREEN	;16
	BCF	PA,VID	;(2*NUMLIN*98)

	BSF	PA,IMP	;1	;POSLEDNI DVA RADKY
	CALL	DT8	;9
	BCF	PA,IMP	;10
	CALL	DT7	;17
	BSF	PA,VID	;18

	MOVLW	D'18'	;19		;#####
	NOP		;20
	NOP		;21
	CALL	DELAY	;21 + 8+(4*17)=97   ;#####

	BCF	PA,VID	;98

	BSF	PA,IMP	;1
	CALL	DT8	;9
	BCF	PA,IMP	;10
	CALL	DT7	;17
	BSF	PA,VID	;18

	MOVLW	D'18'	;19		;#####
	CALL	DELAY	;19 + 8+(4*17)=95   ;#####

;##################################
;#       LICHY PULSNIMEK          #
;##################################

	MOVLW	NUMVI	;96
	MOVWF	RAM0	;97

	BCF	PA,VID	;98

VI3	BSF	PA,IMP	;1	5 VYROVNAVACICH IMPULSU
	CALL	DT4	;5
	BCF	PA,IMP	;6

	DECF	RAM0	;7
	BTFSC	STATUS,Z	;8
	GOTO	EVI3	;9	;10

	MOVLW	D'8'	;10
	BCF	PB,0	;11
	CALL	DELAY	;12 + 8+(4*7)=47

	GOTO	VI3	;49

EVI3	MOVLW	D'8'	;11
	CALL	DELAY	;12 + 8+(4*7)=47

	MOVLW	NUMUI     ;48
	MOVWF	RAM0      ;49

UI2	BSF	PA,IMP	;1

	MOVLW	D'8'	;2
	NOP		;3
	NOP		;4
	NOP		;5
	CALL	DELAY	;5 + 8+(4*7)=41

	BCF	PA,IMP	;42

	DECF	RAM0	;43
	BTFSC	STATUS,Z	;44
	GOTO	EUI2	;45	;46

	NOP		;46
	NOP		;47
	GOTO	UI2	;49

EUI2	NOP		;47

	MOVLW	NUMVI	;48
	MOVWF	RAM0	;49

VI4	BSF	PA,IMP	;1
	CALL	DT4	;5
	BCF	PA,IMP	;6

	DECF	RAM0	;7
	BTFSC	STATUS,Z	;8
	GOTO	EVI4	;9	;10

	MOVLW	D'8'	;10
	NOP		;11
	CALL	DELAY	;11 + 8+(4*7)=47

	GOTO	VI4	;49

EVI4	MOVLW	D'20'	;11	;V LICHEM JE DELSI
	NOP		;12
	CALL	DELAY	;12 + 8+(4*19)=96

	MOVLW	NUMRSI	;97
	MOVWF	RAM0	;98

RSI2	BSF	PA,IMP	;1	;PASIVNI RADEK
	CALL	DT8	;9
	BCF	PA,IMP	;10

	DECF	RAM0	;11
	BTFSC	STATUS,Z	;12
	GOTO	ERSI2	;13	;14

	MOVLW	D'19'	;14
	NOP		;15
	NOP		;16
	CALL	DELAY	;16 + 8+(4*18)=96

     	GOTO	RSI2	;98
     	
ERSI2			;14
	CALL	SCREEN	;
	BCF	PA,VID	;(2*NUMLIN*98)


RSI3	BSF	PA,IMP	;1	;POSLEDNI CELY RADEK
	CALL	DT8	;9
	BCF	PA,IMP	;10
	CALL	DT7	;17
	BSF	PA,VID	;18

	MOVLW	D'18'	;19		;#####
	CALL	DELAY	;19 + 8+(4*17)=95   ;#####

	GOTO	LOOP	;97
	
;##################################
;#       VIDEO ROUTINES           #
;##################################

SCREEN	MOVLW	D'17'	;17
	NOP		;18
	NOP		;19
	CALL	DELAY	;19 + 8+(4*16) = 91

	CLRF	CNTROW	;92
	CLRF	CNTDEL	;93
	CLRF	CNTX	;94
	CLRF	CNTY	;95

	MOVLW	NUMLIN	;96
	MOVWF	RAM0	;97
SCRLOOP	BCF	PA,VID    ;98

	BSF	PA,IMP	;1	;PRVNI RADEK
	CALL	DT8	;9
	BCF	PA,IMP	;10

	NOP
	NOP
	NOP		;13
	
	CALL	ROW	;13 + 82 = 95
	
	NOP
	NOP		;97
	BCF	PA,VID    ;98

	BSF	PA,IMP	;1	;DRUHY RADEK
	CALL	DT8	;9
	BCF	PA,IMP	;10

	DECF	RAM0	;11
	BTFSC	STATUS,Z	;12
	GOTO	ESCR	;13	;14

	CALL	ROW	;13 + 82 = 95

     	GOTO	SCRLOOP	;97

ESCR	MOVLW	D'19'	;15
	CALL	DELAY	;15 + 8+(4*18) = 95
	RETLW	0	;97

ROW			;2

	MOVLW	YSTART	;3
	SUBWF	CNTROW,W	;4
	BTFSS	STATUS,Z  ;5
	GOTO	EROW1	;6	;7

	MOVLW	YSIZE	;7
	SUBWF	CNTY,W	;8
	BTFSC	STATUS,Z  ;9
	GOTO	EROW2	;10	;11
	

LINKA			;11

	MOVF	CNTY,W	;12
	MOVWF	PB	;13	
	BSF	PB,LEY    ;14
	NOP		;15
	BCF	PB,LEY    ;16

	CLRF	PB	;17
	
	CALL	DT5	;22
	CALL	DT4       ;26

	BSF	PA,VID	;27

	BSF	PB,LEX	;28

	INCF	PB	;
	INCF	PB	;
	INCF	PB	;
	INCF	PB	;
	INCF	PB	;
	INCF	PB	;
	INCF	PB	;
	INCF	PB	;

	INCF	PB	;
	INCF	PB	;
	INCF	PB	;
	INCF	PB	;
	INCF	PB	;
	INCF	PB	;
	INCF	PB	;
	INCF	PB	;

	INCF	PB	;
	INCF	PB	;
	INCF	PB	;
	INCF	PB	;
	INCF	PB	;
	INCF	PB	;
	INCF	PB	;
	INCF	PB	;

	INCF	PB	;
	INCF	PB	;
	INCF	PB	;
	INCF	PB	;
	INCF	PB	;
	INCF	PB	;
	INCF	PB	;
	INCF	PB	;

	BCF	PB,LEX	;60

	BCF	PA,VID	;61

	CALL	DT7	;68
	CALL	DT5	;73

EROW	INCF	CNTDEL	;74

	MOVLW	YR	;75
	SUBWF	CNTDEL,W	;76
	BTFSS	STATUS,Z  ;77
	GOTO	EROW3	;78	;79

          CLRF	CNTDEL	;79
          INCF	CNTY      ;80

	RETLW	0	;82

EROW1			;7
	INCF	CNTROW	;8

	MOVLW	D'16'	;9
	NOP		;10
	NOP		;11
	NOP		;12
	CALL	DELAY	;12 + 8+(4*15)=80	;#####

	RETLW	0	;82

EROW2			;11
	MOVLW	D'16'	;12
	CALL	DELAY	;12 + 8+(4*15)=80	;#####

	RETLW	0	;82

EROW3			;79
	NOP		;80
	RETLW	0	;82


;##################################
;#       DELAY ROUTINES           #
;##################################

DT8	NOP		;ZPOZDENI = 8T
DT7	NOP
DT6	NOP
DT5	NOP
DT4	RETLW	0


DELAY	MOVWF	MDELAY	;ZPOZDENI =8+4*(W-1)
DEL1	DECF	MDELAY
	BTFSS	STATUS,Z
	GOTO	DEL1
	RETLW	0


BGF	EQU	0CH	;ZACATEK FILE REGISTRU
RAM0	EQU	BGF       ;JE JICH UZITO 9, PROTOZE MALE PICI
RAM1	EQU	BGF+1	;JICH VIC NEMAJI
MDELAY	EQU	BGF+2
CNTX	EQU	BGF+3
CNTY	EQU	BGF+4
CNTROW	EQU	BGF+5
CNTDEL	EQU	BGF+6
RAM7	EQU	BGF+7
RAM8	EQU	BGF+8	
	
	INCLUDE	".\SOURCE\PIC21PS.EQU"
	END